% \def\draft{1} % Uncomment this if draft mode should be used.
\ifdefined\draft % Draft:
\documentclass[conference, draftcls, onecolumn]{IEEEtran}
\else % Production:
\documentclass[conference]{IEEEtran}
\fi
% \IEEEoverridecommandlockouts
% The preceding line is only needed to identify funding in the first footnote. If that is unneeded, please comment it out.
\usepackage[T1]{fontenc}
\usepackage{cite}
\usepackage{amsmath,amssymb,amsfonts}
\usepackage{graphicx}
\usepackage{textcomp}
\usepackage[table]{xcolor}
\usepackage[binary-units = true]{siunitx}
\usepackage{subfig}
\usepackage{algpseudocode}
\usepackage{url}
\usepackage{pgfplots}
\usepackage{color}
\usepackage{diagbox}
\usepackage{enumerate}
\usepackage{paralist}
\usepackage{xfrac}
\graphicspath{{figs/PDF/}}


\newcommand{\step}[1]{$\varphi_#1$}
\definecolor{blue_grey}{RGB}{96, 125, 139}
\definecolor{blue_grey_200}{RGB}{176, 190, 197}

\begin{document}
	\title{MemOpLight: Leveraging applicative feedback to improve container memory consolidation}

	\author{
		\IEEEauthorblockN{Francis Laniel\IEEEauthorrefmark{3}, Damien Carver\IEEEauthorrefmark{3},
			Julien Sopena\IEEEauthorrefmark{3}, Franck Wajsburt\IEEEauthorrefmark{1},
			Jonathan Lejeune\IEEEauthorrefmark{3} and Marc Shapiro\IEEEauthorrefmark{3}
		}
		\IEEEauthorblockA{\IEEEauthorrefmark{3}\textit{Sorbonne Université, CNRS, Inria, LIP6, DELYS Team, F-75005 Paris, France}}
		\IEEEauthorblockA{\IEEEauthorrefmark{1}\textit{Sorbonne Université, CNRS, LIP6, F-75005 Paris, France}}
		\IEEEauthorblockA{\IEEEauthorrefmark{1}\IEEEauthorrefmark{3}\texttt{firstname.lastname@lip6.fr}}
	}

	\maketitle

	\begin{abstract}
		The container mechanism supports consolidating several servers on the same machine, thus amortizing cost.
		To ensure performance isolation between containers, Linux relies on memory limits.
		However these limits are static, but application needs are dynamic; this results in poor performance.
		To solve this issue, MemOpLight reallocates memory to containers based on dynamic applicative feedback.
		MemOpLight rebalances physical memory allocation, in favor of under-performing ones, with the aim of improving overall performance.
		This paper presents the issues, explains the design of MemOpLight, and validates it experimentally.
		Our approach increases total satisfaction by 13\% compared to the default.
	\end{abstract}

	\begin{IEEEkeywords}
		Linux, container, memory, memory consolidation
	\end{IEEEkeywords}

	\input{TEX/intro.tex}
	\input{TEX/technical_background.tex}
	\input{TEX/problem.tex}
	\input{TEX/solution.tex}
	\input{TEX/evaluation.tex}
	\input{TEX/related.tex}
	\input{TEX/conclusion.tex}

	\bibliographystyle{IEEEtranS}
	\bibliography{IEEEabrv,ccgrid}
\end{document}